using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;

using SpringCard_I2c_API;

namespace I2C_Explorer_CSharp
{
	public class Form1 : System.Windows.Forms.Form
	{
		private const byte TRUE = 1;
		private const byte FALSE= 0;

		private const short SHORT_LEN=    32;
		private const short LONG_LEN = 16384;

        private System.Windows.Forms.Button buttonRead;
		private System.Windows.Forms.TextBox textBoxContent;
		private System.Windows.Forms.Button buttonWrite;
		private System.Windows.Forms.ComboBox comboBox4;
		private System.Windows.Forms.ComboBox comboBox3;
		private System.Windows.Forms.ComboBox comboBox2;
		private System.Windows.Forms.ComboBox comboBox1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button buttonReadAll;
		private System.Windows.Forms.Button buttonWriteAll;
		private System.Windows.Forms.TextBox textBoxTime;
		private System.Windows.Forms.MainMenu mainMenu1;


		/**********************************************/
		public Form1()
		{
			InitializeComponent();

			for (int i=0; i<16; i++)
			{
				string str= string.Format ("{0:X01}", i);
				comboBox1.Items.Add (str);
				comboBox2.Items.Add (str);
				comboBox3.Items.Add (str);
				comboBox4.Items.Add (str);
			}

			comboBox1.SelectedIndex= 0;
			comboBox2.SelectedIndex= 0;
			comboBox3.SelectedIndex= 0;
			comboBox4.SelectedIndex= 0;

			setEditData (null, 0);
		}
		/**********************************************/


		/**********************************************/
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		/**********************************************/

		#region Code gnr par le Concepteur Windows Form
	
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.comboBox4 = new System.Windows.Forms.ComboBox();
			this.comboBox3 = new System.Windows.Forms.ComboBox();
			this.comboBox2 = new System.Windows.Forms.ComboBox();
			this.comboBox1 = new System.Windows.Forms.ComboBox();
			this.buttonRead = new System.Windows.Forms.Button();
			this.textBoxContent = new System.Windows.Forms.TextBox();
			this.buttonWrite = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.buttonReadAll = new System.Windows.Forms.Button();
			this.buttonWriteAll = new System.Windows.Forms.Button();
			this.textBoxTime = new System.Windows.Forms.TextBox();
			// 
			// comboBox4
			// 
			this.comboBox4.Location = new System.Drawing.Point(92, 8);
			this.comboBox4.Size = new System.Drawing.Size(32, 21);
			// 
			// comboBox3
			// 
			this.comboBox3.Location = new System.Drawing.Point(124, 8);
			this.comboBox3.Size = new System.Drawing.Size(32, 21);
			// 
			// comboBox2
			// 
			this.comboBox2.Location = new System.Drawing.Point(156, 8);
			this.comboBox2.Size = new System.Drawing.Size(32, 21);
			// 
			// comboBox1
			// 
			this.comboBox1.Location = new System.Drawing.Point(188, 8);
			this.comboBox1.Size = new System.Drawing.Size(32, 21);
			// 
			// buttonRead
			// 
			this.buttonRead.Location = new System.Drawing.Point(4, 208);
			this.buttonRead.Size = new System.Drawing.Size(68, 24);
			this.buttonRead.Text = "Read";
			this.buttonRead.Click += new System.EventHandler(this.buttonRead_Click);
			// 
			// textBoxContent
			// 
			this.textBoxContent.Location = new System.Drawing.Point(4, 36);
			this.textBoxContent.Multiline = true;
			this.textBoxContent.ScrollBars = System.Windows.Forms.ScrollBars.Both;
			this.textBoxContent.Size = new System.Drawing.Size(232, 144);
			this.textBoxContent.Text = "";
			// 
			// buttonWrite
			// 
			this.buttonWrite.Location = new System.Drawing.Point(168, 208);
			this.buttonWrite.Size = new System.Drawing.Size(68, 24);
			this.buttonWrite.Text = "Write";
			this.buttonWrite.Click += new System.EventHandler(this.buttonWrite_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(4, 12);
			this.label1.Size = new System.Drawing.Size(76, 20);
			this.label1.Text = "Address:";
			// 
			// buttonReadAll
			// 
			this.buttonReadAll.Location = new System.Drawing.Point(40, 240);
			this.buttonReadAll.Size = new System.Drawing.Size(68, 24);
			this.buttonReadAll.Text = "Read All";
			this.buttonReadAll.Click += new System.EventHandler(this.buttonReadAll_Click);
			// 
			// buttonWriteAll
			// 
			this.buttonWriteAll.Enabled = false;
			this.buttonWriteAll.Location = new System.Drawing.Point(132, 240);
			this.buttonWriteAll.Size = new System.Drawing.Size(68, 24);
			this.buttonWriteAll.Text = "Write All";
			this.buttonWriteAll.Click += new System.EventHandler(this.buttonWriteAll_Click);
			// 
			// textBoxTime
			// 
			this.textBoxTime.Location = new System.Drawing.Point(4, 184);
			this.textBoxTime.ReadOnly = true;
			this.textBoxTime.Size = new System.Drawing.Size(232, 20);
			this.textBoxTime.Text = "";
			// 
			// Form1
			// 
			this.Controls.Add(this.textBoxTime);
			this.Controls.Add(this.buttonWriteAll);
			this.Controls.Add(this.buttonReadAll);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.buttonWrite);
			this.Controls.Add(this.textBoxContent);
			this.Controls.Add(this.buttonRead);
			this.Controls.Add(this.comboBox1);
			this.Controls.Add(this.comboBox2);
			this.Controls.Add(this.comboBox3);
			this.Controls.Add(this.comboBox4);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.MaximizeBox = false;
			this.Menu = this.mainMenu1;
			this.MinimizeBox = false;
			this.Text = "I2C Explorer C#";

		}
		#endregion

		

		/**********************************************/
		static void Main() 
		{
			Application.Run(new Form1());
		}
		/**********************************************/


		/**********************************************/
		private void buttonRead_Click(object sender, System.EventArgs e)
		{
			read (readAddress (), SHORT_LEN);
		}
		/**********************************************/


		/**********************************************/
		private void buttonWrite_Click(object sender, System.EventArgs e)
		{
			write (readAddress (), SHORT_LEN);
		}
		/**********************************************/


		/**********************************************/
		private void buttonReadAll_Click(object sender, System.EventArgs e)
		{
			read (0, LONG_LEN);
		}
		/**********************************************/


		/**********************************************/
		private void buttonWriteAll_Click(object sender, System.EventArgs e)
		{
			write (0, LONG_LEN);
		}
		/**********************************************/


		/**********************************************/
		private void read (short addr, short len)
		{
			byte [] buffer= new byte [len];
			byte    rc;
			
			Cursor.Current= Cursors.WaitCursor;
			setEditData (null, 0);
			textBoxTime.Text= "";

			int tc1=Environment.TickCount;
			rc= SCard_I2c_API.ReadI2CCard (TRUE, buffer, addr, len);
			int tc2=Environment.TickCount;

			displayTime (tc2-tc1);
			
			if (rc != TRUE)
				textBoxContent.Text= "Read failed";
			else
			{
				textBoxContent.Text= "Formatting data...";
				setEditData (buffer, len);
			}

			Cursor.Current= Cursors.Default;
		}
		/**********************************************/


		/**********************************************/
		private void write (short addr, short len)
		{
			byte [] buffer=new byte [len];
			byte    rc;

			Cursor.Current= Cursors.WaitCursor;

			getEditData (buffer, len);
			
			int tc1=Environment.TickCount;
			rc= SCard_I2c_API.WriteI2CCard (TRUE, buffer, addr, len);
			int tc2=Environment.TickCount;

			displayTime (tc2-tc1);

			if (rc != TRUE)
				textBoxContent.Text= "Write failed";
			else
			{
				textBoxContent.Text= "Formatting data...";
				setEditData (buffer, len); // update display
			}

			Cursor.Current= Cursors.Default;
		}
		/**********************************************/


		/**********************************************/
		private short readAddress ()
		{
			byte b1_1= byte.Parse(comboBox1.Text, System.Globalization.NumberStyles.AllowHexSpecifier);
			byte b1_2= byte.Parse(comboBox2.Text, System.Globalization.NumberStyles.AllowHexSpecifier);
			byte b2_1= byte.Parse(comboBox3.Text, System.Globalization.NumberStyles.AllowHexSpecifier);
			byte b2_2= byte.Parse(comboBox4.Text, System.Globalization.NumberStyles.AllowHexSpecifier);

			byte b1= (byte) ((b1_2<<4) | b1_1);
			byte b2= (byte) ((b2_2<<4) | b2_1);

			short addr= (short) ((b2 << 8) | b1);

			return addr;
		}
		/**********************************************/


		/**********************************************/
		private void setEditData (byte [] data, int len)
		{
			string str= "";
			if (data != null)
			{
				int i, min;
				byte [] array= new byte [len * 2];
				byte b1= 0;
				byte b2= 0;

				min= data.Length < len ? data.Length : len;

				for (i=0; i<len; i++)
					if (i < min)
					{
						b1 = data[i];
						b1&= 0x0F;

						b2  = data[i];
						b2>>= 4;
				
						if (b1 < 10)
							b1+= 48;
						else
							b1+= 65;

						if (b2 < 10)
							b2+= 48;
						else
							b2+= 65;

						array[2*i]  = b2;
						array[2*i+1]= b1;
					}
					else
					{
						array[2*i]= 0;
						array[2*i+1]= 0;
					}

				str= System.Text.Encoding.ASCII.GetString (array, 0, len*2);
			}

			textBoxContent.Text= str;
		}
		/**********************************************/


		/**********************************************/
		private bool getEditData (byte [] data, int len)
		{
			if (data == null)
				return false;

			string str= textBoxContent.Text;
			int count= str.Length;
			if ( (count%2) != 0 )
				count--;
			
			count/=2;
			for (int i=0; i<len; i++)
			{
				byte b;

				if (i < count)				
					try
					{
						string substr= str.Substring (i*2, 2);
						b= byte.Parse (substr, System.Globalization.NumberStyles.AllowHexSpecifier);
					}
					catch (Exception)
					{
						b= 0;
					}
				else
					b= 0;

				if (i<len && i<data.Length)
					data[i]= b;
			}

			return true;
		}
		/**********************************************/


		/**********************************************/
		private void displayTime (int tickCount)
		{
			int s = tickCount/1000;
			int ms= tickCount%1000;

			int h = s/3600;
			int mn= (s%3600)/60;

			s%= 60;

			textBoxTime.Text= string.Format ("Performed in {0}mn {1}s {2}ms", mn, s, ms);
		}
		/**********************************************/
	}
}
