/*******************************************************************************
*               Copyright (c) Gemplus Card International 1997
*
* Name        : c2bin.c
*
* Description : 

  Author      : JL GIRAUD
  Compiler    : Visual C++, linux compiler
  Host        : Windows 9x,NT, Linux
*
* $Id: c2bin.c,v 1.2 2000/09/04 08:19:06 rousseau Exp $
* $Log: c2bin.c,v $
* Revision 1.2  2000/09/04 08:19:06  rousseau
* code cleanup, changed the API and name for [Init|Close]Serial
*
*
********************************************************************************
*
* Warning     : 
*
* Remarks     : 
*
*******************************************************************************/

#include "c2bin.h"

/* Transforms an ASCII chain of length characters in an int */
/* Any invalid character is discarded and treated as zero   */
int c2bin(const char *buffer, int length)
{
  int     result;
  int     i;

  result = 0;
  for (i = 0; i < length; i++)
  {
    if ((buffer[i] >= '0') && (buffer[i] <= '9'))
      result += buffer[i] - '0';
    else if ((buffer[i] >= 'A') && (buffer[i] <= 'F'))
      result += buffer[i] - 'A' + 10;
    else if ((buffer[i] >= 'a') && (buffer[i] <= 'f'))
      result += buffer[i] - 'a' + 10;
    /* Shifting should not happen on the last step */
    if (i < (length - 1))
      result <<= 4;
  }
  return result;
}

/*
int c2bin2(const char *buffer)
{
  return c2bin(buffer, 2);
}
*/
