#ifndef _SPRINGCARD_S10_I_H_
#define _SPRINGCARD_S10_I_H_

#ifdef WIN32
  #include <windows.h>
  #define SPRINGCARD_S10_LIB __declspec( dllexport )
#endif

#include "springcard_s10.h"

#define MAX_BYTE_TO_READ 128
    
/* scard_s10_low */
LONG SCardS10CardDirect(SCARDHANDLE hCard, BYTE send_len, BYTE *send_data, BYTE recv_len, BYTE *recv_data, BYTE status[2]);
LONG SCardS10CardTransmit(SCARDHANDLE hCard, BYTE send_len, BYTE *send_data, BYTE recv_len, BYTE *recv_data, BYTE status[2]);

/* scard_s10_gcr_1.5x */
LONG PosS10ReadDataArea(SCARDHANDLE hCard, BYTE *recv_data, BYTE addr, BYTE recv_len, BYTE status[2]);
LONG PosS10ReadProtectionArea(SCARDHANDLE hCard, BYTE recv_data[4], BYTE status[2]);
LONG PosS10ReadSecurityArea(SCARDHANDLE hCard, BYTE recv_data[4], BYTE status[2]);
LONG PosS10WriteDataArea(SCARDHANDLE hCard, BYTE *write_data, BYTE addr, BYTE write_len, BYTE status[2]);
long PosS10WriteProtectionArea(SCARDHANDLE hCard, BYTE *write_data, BYTE addr, BYTE write_len, BYTE status[2]);
LONG PosS10UpdateSecurityArea(SCARDHANDLE hCard, BYTE *update_data, BYTE addr, BYTE update_len, BYTE status[2]);
LONG PosS10PSCVerification(SCARDHANDLE hCard, BYTE code3, BYTE code2, BYTE code1, BYTE status[2]);

/* scard_s10_gcr_1.4x */
LONG LiteProS10ReadDataArea(SCARDHANDLE hCard, BYTE *recv_data, BYTE addr, BYTE recv_len, BYTE status[2]);
LONG LiteProS10ReadProtectionArea(SCARDHANDLE hCard, BYTE recv_data[4], BYTE status[2]);
LONG LiteProS10ReadSecurityArea(SCARDHANDLE hCard, BYTE recv_data[4], BYTE status[2]);
LONG LiteProS10WriteDataArea(SCARDHANDLE hCard, BYTE *write_data, BYTE addr, BYTE write_len, BYTE status[2]);
LONG LiteProS10WriteProtectionArea(SCARDHANDLE hCard, BYTE *write_data, BYTE addr, BYTE write_len, BYTE status[2]);
LONG LiteProS10UpdateSecurityArea(SCARDHANDLE hCard, BYTE *update_data, BYTE addr, BYTE update_len, BYTE status[2]);
LONG LiteProS10PSCVerification(SCARDHANDLE hCard, BYTE code3, BYTE code2, BYTE code1, BYTE status[2]);

#endif