/*
 *
 * Apdu header du Springcard Pro-Active
 */

#ifndef   __APDU_H__
#define   __APDU_H__

//#include "../../lib-c/types.h"

/* Commandes APDU */
#define APDU_READ_BINARY        0xB0
#define APDU_WRITE_BINARY       0xD0
#define APDU_ERASE_BINARY       0x0E
#define APDU_UPDATE_BINARY      0xD6
#define APDU_READ_RECORD        0xB2
#define APDU_WRITE_RECORD       0xD2
#define APDU_UPADTE_RECORD      0xDC
#define APDU_APPEND_RECORD      0xE2
#define APDU_GET_DATA           0xCA
#define APDU_PUT_DATA           0xDA
#define APDU_SELECT_FILE        0xA4
#define APDU_VERIFY             0x20
#define APDU_INTERNAL_AUTH      0x88
#define APDU_EXTERNAL_AUTH      0x82
#define APDU_GET_CHALLENGE      0x84  
#define APDU_MANAGER_CHANNEL    0x70

#define APDU_GET_RESPONSE       0xC0
#define APDU_ENVELOPE           0xC2

bool APDU_error_display(BOOL sim);
bool APDU_set_delay(BYTE timeout);
void APDU_shutdown(BOOL sim);
void APDU_pts(BOOL sim, BYTE ta1);
bool CardOpen(bool sim_card , bool mode_emv, bool pts_auto);
bool CardClose(void);
bool CardPresent(void);
bool APDU_init(BOOL sim, BYTE config , BYTE type, BYTE voltage);
bool ReaderOpen(void);
void ReaderClose(void);
bool SpringCard_ApduExchange(LPCTSTR ApduStr, DWORD ApduLen, TCHAR *ResultStr ,DWORD ResultLen);

#endif