/*******************************************************************************
*               Copyright (c) Gemplus Card International 1997
*
* Name        : bin2c.c
*
* Description : 

  Author      : JL GIRAUD
  Compiler    : Visual C++, GNU gcc compiler
  Host        : Windows 9x,NT, Linux
*
* $Id: bin2c.c,v 1.2 2000/09/04 08:19:06 rousseau Exp $
* $Log: bin2c.c,v $
* Revision 1.2  2000/09/04 08:19:06  rousseau
* code cleanup, changed the API and name for [Init|Close]Serial
*
*
********************************************************************************
*
* Warning     : 
*
* Remarks     : 
*
*******************************************************************************/
#include "stdafx.h"


/* Transforms int value in a length char array   */
void bin2c(int value, char* buffer, int length)
{
	int i;
	int nibble;

	for (i = 0; i < length; i++)
	{
		nibble = value - (value >> 4 <<4);
		if (nibble < 10)
		{
			buffer[length-1-i] = nibble + '0';
		}
		else
		{
			buffer[length-1-i] = nibble -10 + 'A';
		}
		value >>= 4;
	}
}
/* Transforms an ASCII chain of length characters in an int */
/* Any invalid character is discarded and treated as zero   */
int c2bin(const char* buffer, int length)
{
  int result;
  int i;
 
  result = 0;
  for (i = 0; i < length ; i++)
  {
    if ((buffer[i] >= '0') && (buffer[i] <= '9'))
  	  result += buffer[i] - '0';
    else
    if ((buffer[i] >= 'A') && (buffer[i] <= 'F'))
      result += buffer[i] - 'A' + 10;
    else
    if ((buffer[i] >= 'a') && (buffer[i] <= 'f'))
      result += buffer[i] - 'a' + 10;
    /* Shifting should not happen on the last step */
    if ( i < (length - 1) )
      result <<= 4;
  }
  return result;
}

/* Transforms int value in a Transforms an ASCII Hexa chain */
char bin2hex(int v)
{
  char result[2];

  if (( v >= 0) && ( v<= 9))
  {
	bin2c(v, result, 1);
	return result[0];
  }
  if (( v >= 10) && ( v<= 15))
	return( v+ 0x37);

  return '0';	
}
