/**h* 
 *
 * NAME
 *   Springcard_i2c.h
 *
 * DESCRIPTION
 *
 *   API d'acces aux cartes I2C
 *
 * SEE ALSO
 *
 * PORTABILITY
 *   Microsoft eMbedded Visual C++ 3.00 + PocketPC 2002 SDK
 *
 * AUTHOR
 *   Pro-Active - www.pro-active.fr
 *
 * HISTORY
 *   26/09/2003  denis.p@pro-active.fr
 *
 *
 **/
#ifndef __SPRINGCARD_I2C_H__
#define __SPRINGCARD_I2C_H__

/****************************************************************************

  Circuiterie d'assemblage de la DLL

 ***************************************************************************/

#include "springcard.h"
#include <windows.h>


/* Ce meme .h sert a la fois pour l'import et pour l'export */
#ifdef MAKE_SPRINGCARD_I2C_DLL
  #define SPRINGCARD_I2C_LIB __declspec( dllexport )
#else
  #define SPRINGCARD_I2C_LIB __declspec( dllimport )
#endif

/* Le linkage est different selon la plateforme, pour faciliter la vie avec
   Delphi sur PC et VB sur PocketPC. Tout cela peut evidemment etre modifie
   sans probleme si ces deux outils ne sont pas utilises                   */
#ifndef UNDER_CE
  /* Desktop Windows */
  #define SPRINGCARD_I2C_API __cdecl
#else
  /* Windows CE or PocketPC */
  #define SPRINGCARD_I2C_API __stdcall
#endif

/* Toutes les fonctions renvoient un booleen avec le bon linkage */
#define SPRINGCARD_I2C_BOOL SPRINGCARD_I2C_LIB BOOL SPRINGCARD_I2C_API

/* Attention, le PocketPC est purement UNICODE !!! Les macros suivantes
   permettent de s'affranchir des details...                               */

#ifdef UNICODE
  #define CardI2CRead  CardI2CReadW
  #define CardI2CWrite CardI2CWriteW

#else
  #define CardI2CRead  CardI2CReadA
  #define CardI2CWrite CardI2CWriteA

#endif

/* La DLL est en C */
#ifdef __cplusplus
extern "C" {
#endif

/**f* SpringCard_I2c/CardRead
 *
 * NAME
 *   CardRead
 *
 * DESCRIPTION
 *   Read some Bytes
 *   
 * INPUTS
 *    dest     : Buffer
 *    addr_hi  : MSB address
 *    addr_low : LSB address
 *    len      : Length (Max 32)
 * RETURNS
 *   TRUE/FALSE
 **/
SPRINGCARD_I2C_BOOL CardI2CRead (BOOL extended_address, BYTE *dest, BYTE addr_hi, BYTE addr_low,BYTE len);
SPRINGCARD_I2C_BOOL ReadI2CCard (BOOL extended_address, BYTE *dest, WORD addr   ,WORD len);

/**f* SpringCard_I2c/CardWrite
 *
 * NAME
 *   CardWrite
 *
 * DESCRIPTION
 *   Initialisation et ouverture de l'acces au lecteur SpringProx
 *   
 * INPUTS
 *    dest     : Buffer
 *    addr_hi  : MSB address
 *    addr_low : LSB address
 *    len      : Length (Max 32)
 * RETURNS
 *   TRUE/FALSE
 **/
SPRINGCARD_I2C_BOOL CardI2CWrite (BOOL extended_address, BYTE *source, BYTE addr_hi, BYTE addr_low,BYTE len);
SPRINGCARD_I2C_BOOL WriteI2CCard (BOOL extended_address, BYTE *source, WORD addr   , WORD len);

/* La DLL est en C */
#ifdef __cplusplus
}
#endif

#endif